ModLuaFileAppend("data/scripts/gun/gun_actions.lua", "mods/icenine/files/spell_appends.lua")

-- all functions below are optional and can be left out

--[[

function OnModPreInit()
	print("Mod - OnModPreInit()") -- First this is called for all mods
end

function OnModInit()
	print("Mod - OnModInit()") -- After that this is called for all mods
end

function OnModPostInit()
	print("Mod - OnModPostInit()") -- Then this is called for all mods
end

function OnPlayerSpawned(player) -- This runs when player entity has been created
	local x, y = EntityGetTransform(player)
	CreateItemActionEntity("MY_CUSTOM_SPELL", x+20, y)
	CreateItemActionEntity("MY_CUSTOM_SPELL", x, y)
end

function OnWorldInitialized() -- This is called once the game world is initialized. Doesn't ensure any world chunks actually exist. Use OnPlayerSpawned to ensure the chunks around player have been loaded or created.
	GamePrint( "OnWorldInitialized() " .. tostring(GameGetFrameNum()) )
end

function OnWorldPreUpdate() -- This is called every time the game is about to start updating the world
	GamePrint( "Pre-update hook " .. tostring(GameGetFrameNum()) )
end
]]--


function OnWorldPostUpdate() -- This is called every time the game has finished updating the world
	local entities = EntityGetWithTag( "homing_target" )
	table.insert(entities, EntityGetWithTag( "player_unit" )[1])
	for i, entity in pairs(entities) do
		if not EntityHasTag( entity, "ice_nine_vulnerable" ) then
			EntitySetDamageFromMaterial( entity, "ice_nine", -0.00000001 ) 
			EntitySetDamageFromMaterial( entity, "ice_nine_static", -0.00000001 ) 
			EntitySetDamageFromMaterial( entity, "ice_nine_dynamic", -0.00000001 ) 
			EntitySetDamageFromMaterial( entity, "ice_nine_transition", -0.00000001 ) 
			EntitySetDamageFromMaterial( entity, "ice_nine_react", -0.00000001 ) 
			EntityAddTag( entity, "ice_nine_vulnerable" )
		else
			local dmc = EntityGetFirstComponent( entity, "DamageModelComponent")
			local dmg_mats  = ComponentGetValue2( dmc, "mDamageMaterials")
			local count = 0
			for i, mat in pairs(dmg_mats) do
				material = CellFactory_GetName(mat)
				if material == "ice_nine" or  material == "ice_nine_static" or material == "ice_nine_dynamic" or material == "ice_nine_transition" or material == "ice_nine_react" then
					count = count + ComponentGetValue2( dmc, "mMaterialDamageThisFrame")[i]
				end
			end
			local cellcount = count * -500000
			local effect_comp = EntityGetFirstComponentIncludingDisabled(entity, "StatusEffectDataComponent")
			local effects = ComponentGetValue2(effect_comp, "stain_effects")
			if (cellcount > 0) then 
				if cellcount+0.15 > effects[41] and IsPlayer(entity) then
					EntityAddRandomStains( entity, CellFactory_GetType( "ice_nine_stain_color" ), 1 )
				elseif not IsPlayer(entity) then
					EntityAddRandomStains( entity, CellFactory_GetType( "ice_nine_stain_color" ), 1 )
				end
			end
		end
	end
end




function OnPlayerSpawned(player) -- This runs when player entity has been created
	local x, y = EntityGetTransform(player)
	if not GameHasFlagRun( "ice_nine_started" ) then
		flask = EntityLoad("data/entities/items/potion_ice_nine.xml", x, y-8)
		GamePickUpInventoryItem( player, flask, false )
		GameAddFlagRun( "ice_nine_started" )
	end
end

function OnMagicNumbersAndWorldSeedInitialized() -- this is the last point where the Mod* API is available. after this materials.xml will be loaded.
	local x = ProceduralRandom(0,0)
	print( "===================================== random " .. tostring(x) )
end


-- This code runs when all mods' filesystems are registered
ModMaterialsFileAdd( "mods/icenine/files/materials_ice_nine.xml" ) 
ModLuaFileAppend( "data/scripts/items/potion.lua", "mods/icenine/files/potion_appends.lua" )
ModLuaFileAppend("data/scripts/status_effects/status_list.lua", "mods/icenine/files/status_list_appends.lua")

print("Example mod init done")